/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.CurrencyRate;

import java.math.BigDecimal;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record4;
import org.jooq.Record5;
import org.jooq.Row5;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CurrencyRateRecord extends UpdatableRecordImpl<CurrencyRateRecord> implements Record5<String, String, String, String, BigDecimal> {

    private static final long serialVersionUID = 1191112510;

    /**
     * Setter for <code>currency_rate.year</code>.
     */
    public void setYear(String value) {
        set(0, value);
    }

    /**
     * Getter for <code>currency_rate.year</code>.
     */
    public String getYear() {
        return (String) get(0);
    }

    /**
     * Setter for <code>currency_rate.month</code>.
     */
    public void setMonth(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>currency_rate.month</code>.
     */
    public String getMonth() {
        return (String) get(1);
    }

    /**
     * Setter for <code>currency_rate.src_currency</code>.
     */
    public void setSrcCurrency(String value) {
        set(2, value);
    }

    /**
     * Getter for <code>currency_rate.src_currency</code>.
     */
    public String getSrcCurrency() {
        return (String) get(2);
    }

    /**
     * Setter for <code>currency_rate.dst_currency</code>.
     */
    public void setDstCurrency(String value) {
        set(3, value);
    }

    /**
     * Getter for <code>currency_rate.dst_currency</code>.
     */
    public String getDstCurrency() {
        return (String) get(3);
    }

    /**
     * Setter for <code>currency_rate.rate</code>.
     */
    public void setRate(BigDecimal value) {
        set(4, value);
    }

    /**
     * Getter for <code>currency_rate.rate</code>.
     */
    public BigDecimal getRate() {
        return (BigDecimal) get(4);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record4<String, String, String, String> key() {
        return (Record4) super.key();
    }

    // -------------------------------------------------------------------------
    // Record5 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row5<String, String, String, String, BigDecimal> fieldsRow() {
        return (Row5) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row5<String, String, String, String, BigDecimal> valuesRow() {
        return (Row5) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field1() {
        return CurrencyRate.CURRENCY_RATE.YEAR;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return CurrencyRate.CURRENCY_RATE.MONTH;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field3() {
        return CurrencyRate.CURRENCY_RATE.SRC_CURRENCY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field4() {
        return CurrencyRate.CURRENCY_RATE.DST_CURRENCY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field5() {
        return CurrencyRate.CURRENCY_RATE.RATE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component1() {
        return getYear();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getMonth();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component3() {
        return getSrcCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component4() {
        return getDstCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component5() {
        return getRate();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value1() {
        return getYear();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getMonth();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value3() {
        return getSrcCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value4() {
        return getDstCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value5() {
        return getRate();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CurrencyRateRecord value1(String value) {
        setYear(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CurrencyRateRecord value2(String value) {
        setMonth(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CurrencyRateRecord value3(String value) {
        setSrcCurrency(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CurrencyRateRecord value4(String value) {
        setDstCurrency(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CurrencyRateRecord value5(BigDecimal value) {
        setRate(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CurrencyRateRecord values(String value1, String value2, String value3, String value4, BigDecimal value5) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached CurrencyRateRecord
     */
    public CurrencyRateRecord() {
        super(CurrencyRate.CURRENCY_RATE);
    }

    /**
     * Create a detached, initialised CurrencyRateRecord
     */
    public CurrencyRateRecord(String year, String month, String srcCurrency, String dstCurrency, BigDecimal rate) {
        super(CurrencyRate.CURRENCY_RATE);

        set(0, year);
        set(1, month);
        set(2, srcCurrency);
        set(3, dstCurrency);
        set(4, rate);
    }
}
